﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Web.Script.Serialization;

namespace IntroductionToJQueryBlockUI
{
    /// <summary>
    /// Summary description for AjaxService
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    [System.Web.Script.Services.ScriptService]
    public class AjaxService : System.Web.Services.WebService
    {
        [WebMethod]
        public string GetPersons()
        {
            var list = new List<Person>()
                           {
                               new Person() {FirstName = "Mohammad", LastName = "Azam"},
                               new Person() {FirstName = "John", LastName = "Doe"}
                           };
  

            var json = new JavaScriptSerializer();
            return json.Serialize(list); 
        }


        [WebMethod]
       public string GetProducts()
       {
         using(var northwind = new NorthwindDataContext())
            {
                var json = new JavaScriptSerializer();
                var dtoProducts = (from p in northwind.Products
                                select p.ToDTO<ProductDTO>()); 

                return json.Serialize(dtoProducts); 
            }
       }
    }
}
