﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Reflection;

namespace IntroductionToJQueryBlockUI
{
    public static class ExtensionMethods
    {
        public static T ToDTO<T>(this object o)
        {
            var dto = Activator.CreateInstance<T>();
            
            foreach(var propertyInfo in dto.GetProperties())
            {
                propertyInfo.SetValue(dto,GetPropertyValue(o,propertyInfo.Name),null);
            }

            return dto; 
        }

        private static object GetPropertyValue(object o, string propertyName)
        {
            return o.GetType().GetProperty(propertyName).GetValue(o, null); 
        }

        private static PropertyInfo[] GetProperties(this object o)
        {
            return o.GetType().GetProperties(); 
        }



    }
}
