﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;

namespace TestingAutoMapperConsoleApplication
{
    public static class ExtensionMethods
    {
        public static T ToDTO<T>(this object o) where T : BaseDTO 
        {
            var dto = Activator.CreateInstance<T>();

            foreach (var propertyInfo in dto.GetProperties())
            {
                propertyInfo.SetValue(dto, GetPropertyValue(o,propertyInfo.Name), null);
            }

            return dto;
        }

        private static object GetPropertyValue(object o, string propertyName)
        {
            var obj = o.GetType().GetProperty(propertyName).GetValue(o, null);
            return obj; 
        }

        private static PropertyInfo[] GetProperties(this object o)
        {
            return o.GetType().GetProperties();
        }

    }
}
